/* Copyright 2020, Michele Santullo
 * This file is part of wrenpp.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with wrenpp.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "configuration.hpp"
#include "error_type.hpp"

namespace wren {
	class VM;

	typedef void(*foreign_method_t)(VM&);

	class DefConfiguration : public Configuration {
	public:
		static void write_fn (VM*, const char* text);
		static void error_fn (VM*, ErrorType, const char* module, int line, const char* msg);
		static void* reallocate_fn(void* ptr, std::size_t size);
	};
} //namespace wren
